; ******************************************************************************************************************
; **  REALIZADO POR FADISHOP  Tarjeta: FADICLOCK  	http://www.fadishop.eu	FADITECO, S.L.U. 	Lleonard Garcia	**
; **  Programa de prueba de la funcion 32khz. Efectua lecturas de fecha-hora y temperatura				**
; ** 	Aunqu 32kHz sea muy rpida se habilitan interrupciones por PortC (C.5)							**
; ** 	LA DIRECCIN DEL SLAVE I2C DS3232 ES FIJA $D0.					      					**
; **  ENCAMINAMIENTO INTERRUPCIN 32KHZ(HIGH O LOW)	JP6(JUMPER AZUL)	(C.6=0, C.5=1 C.4=0)				** 
; ******************************************************************************************************************
; CONFIGURACIONES
#picaxe 28x2		
let dirsB=%00000000	; 1=salida 0=entrada
let dirsC=%00000000	; 1=salida 0=entrada
; C.3 I2C_SCL
; C.4 I2C_SDA
;adcsetup = %00000000 	' CONFIGURACIN ENTRADAS ANALGICAS
;setfreq em16		; Resonador/oscilador externo a 16Mhz.
device_DS3232SN:
symbol adress_slave_A =$D0	; Direccin fija I2C del DS3232 $D0
symbol @ahora=$00			; direccin interna de segundos, minutos y hora.
symbol @hoy=$03			; direccin interna de dia_semanal, dia, siglo-mes y ao.
symbol @alm1=$07			; direccin interna de alarma_1(seg, min, hora y dia_sem/dia).
symbol @alm2=$0B			; direccin interna de alarma_2(min, hora y dia_sem/dia).
symbol @control=$0E		; (7)/EOSC (6)BBSQW (5)CONV (4-3)RS2-1 (2)INTCN (1)A2IE (0)A1IE
symbol @status=$0F		; (7)OSF (6)BB32KHZ (5-4)CRATE (3)EN32KHZ (2)BSY (1)A2F (0)A1F
symbol @offset=$10		; offset temperatura. (aade/sustrae capacitancia)
symbol @temp=$11			; direccin word interna de MSB_temperatura y LSB_temperatura.
symbol @test=$13			; reservada par test.
symbol @sram=$14			; direccin interna del inicio del bloque de 235 bytes SRAM.
symbol control=b16		; variable control DS3232.
symbol status=b18			; variable control/status DS3232.

; DEFINICIONES
symbol segundos=b0
symbol minutos=b1
symbol hora=b2			
symbol dia_sem=b3
symbol dia=b4
symbol mes=b5
symbol anno=b6
symbol T_msb=b7
symbol T_lsb=b8

;INICIALITZACIONES:
let control=%00011100					; coincide con inicializacin por defecto.POR (power on reset).
;let control=control and %11111011			; bit(2)INTCN=0. La salida INT/SQW est en formato de onda de salida.
let control=control and %11100111			; bits(3-4)RS1=0,RS2=0.Frequencia de SQUARE-WAVE: 1HZ.
;let control=control or %01000000			; bit(6)=1-->INT/SQW oscila cuando Vbat alimente a DS3232.
let status=%11001000					; coincide con inicializacin por defecto.POR (power on reset).
;let status=status and %11110111			; bit(3)=0-->Se impide salida(32khz) cuando Vcc alimente a DS3232.
;let status=status and %10111111			; bit(6)=0-->Se impide salida(32khz) cuando Vbat alimente a DS3232.
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del DS3232 (0XD0-0XD1)
writei2c @control,(control,status)			; Se envian ajustes y habilitaciones
;call fijar_fecha_hora					; modifica la fecha-hora del RTC DS3232.
;call fijar_alarma1					; fija la alarma_1 del RTC DS3232.
configuracio_interrupcions:
setint %00100000,%00100000 				; por nivel alto se habilitan interrupciones en el pinC.5. 
main:
;i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del DS3232 (0XD0-0XD1)
;readi2c @ahora,(segundos,minutos,hora,dia_sem)	; lectura hora actual.
;readi2c @hoy,(dia,mes,anno)				; lectura fecha actual.
;readi2c @temp,(T_msb,T_lsb)				; lectura temperatura.
;readi2c @alm1,(b10,b11,b12,b13)			; lectura alarma_1.
;readi2c @control,(b17,b19)				; lectura registres
debug								; cada vez que se ejecuta interrupcin hace un debug.
pause 1000
goto main

; SECUENCIA DE INTERRUPCIN
interrupt:							; Ha estado anteriormente en nivel bajo?   MSB:b21, LSB:b22.
if b21=0 then inc w12					; (SI) Incrementar
		  let b21=255				; (SI) Anota que est en nivel alto.
		  setint %00000000,%00100000 		; (SI) Por nivel bajo se habilitan interrupciones en el pinC.5.
	   else let b21=0					; (NO) Anota que est en nivel bajo.
		  setint %00100000,%00100000 		; (NO) Por nivel alto se habilitan interrupciones en el pinC.5.
endif
return							; Despus de return es cuando realmente habilita la interrupcin.

fijar_fecha_hora:
symbol xseg=$25						; @_interna DS3232: $00
symbol xminu=$00						; @_interna DS3232: $01
symbol xhora=$13						; @_interna DS3232: $02
symbol xsemdia=$00					; @_interna DS3232: $03
symbol xdia=$03						; @_interna DS3232: $04
symbol xmes=$03						; @_interna DS3232: $05
symbol xanno=$12						; @_interna DS3232: $06
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del DS3232 (0XD0-0XD1)
writei2c @ahora,(xseg,xminu,xhora,xsemdia,xdia,xmes,xanno); Se envia fecha-hora actual al RTC DS3232
return

fijar_alarma1:
symbol a1_seg=$00
symbol a1_min=$01
symbol a1_hor=$13						; Formato hora->bit(6)=0:24h, bit(6)=1:AM/PM 12h.
symbol a1_dia_sem=$03					; Formato dia-> bit(6)=0:dia del mes, bit(6)=1:dia de la semana.
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del DS3232 (0XD0-0XD1)
writei2c @alm1,(a1_seg,a1_min,a1_hor,a1_dia_sem); Se envia la configuracin de la alarma_1.
let control=control or %00000001			; Se habilita alarma_1 por interrupcin A1E.
let control=control or %00000100			; Se habilita interrupcin por alarmas INTCN en DS3232.
let status=status and %11111110			; Se borra el flag de alarma_1 en DS3232.
writei2c @control,(control,status)			; Se envia habilitacin y borrado de flag A1F.
return

fijar_alarma2:
symbol a2_min=$01
symbol a2_hor=$13						; Formato hora->bit(6)=0:24h, bit(6)=1:AM/PM 12h.
symbol a2_dia_sem=$03					; Formato dia-> bit(6)=0:dia del mes, bit(6)=1:dia de la semana.
i2cslave adress_slave_A, i2cslow, i2cbyte		; Direccin I2C del DS3232 (0XD0-0XD1)
writei2c @alm2,(a2_min,a2_hor,a2_dia_sem)		; Se envia la configuracin de la alarma_2.
let control=control or %00000010			; Se habilita alarma_1 por interrupcin A2E.
let control=control or %00000100			; Se habilita interrupcin por alarmas INTCN en DS3232.
let status=status and %11111101			; Se borra el flag de alarma_2 en DS3232.
writei2c @control,(control,status)			; Se envia habilitacin y borrado de flag A2F.
return